#!/usr/bin/env python
import sys, os
from reverend.thomas import Bayes
from singleton import db, sqlite

filename = 'bayes.pickle'
guesser = Bayes()

c = db.cursor()

try:
  print >> sys.stderr, 'loading saved classifier...',
  guesser.load(filename)
  print >> sys.stderr, 'done'
except IOError:  
  print >> sys.stderr, 'not found, regenerating'
  c.execute("""select item_uid, item_content from fm_items
  where item_rating>0""")
  for uid, content in c:
    try:
      guesser.train('interesting', content)
      sys.stderr.write('I')
    except sqlite.Error, e:
      print >> sys.stderr, uid, e
  sys.stderr.write('\n')
  c.execute("""select item_uid, item_content from fm_items
  where item_rating=-1 and item_content<>'' """)
  for uid, content in c:
    if content:
      try:
        guesser.train('boring', content)
        sys.stderr.write('B')
      except sqlite.Error, e:
        print >> sys.stderr, uid, e
  sys.stderr.write('\n')
  guesser.save(filename)

c.execute("""select item_uid, item_title, item_content from fm_items
where item_rating=0 order by item_uid""")
for uid, title, content in c:
  P = dict(guesser.guess(content))
  if P['interesting']> 0.9 and P['interesting'] > P['boring']:
    assess = 'INTERESTING %4.2f' % (100 * P['interesting'])
  else:
    assess = 'BORING'
  print assess, title
